package edu.gmu.calc;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Stack;

/**
 * A Reverse Polish notation calculator.
 */
public class RpnCalculator {

    public enum Operator {
        ADD, SUBTRACT, MULTIPLY, DIVIDE
    }

    public class InvalidOperation extends RuntimeException {

        public InvalidOperation(String msg) {
            super(msg);
        }
    }

    private Stack<Double> operands;

    public RpnCalculator() {
        operands = new Stack<Double>();
    }

    private void add() {

    }

    private void subtract() {

    }

    private void multiply() {

    }

    private void divide() {

    }

    public void push(double operand) {

    }

    /**
     * Peek at the top of the stack.
     * @return
     */
    public double peek() {

    }

    /**
     * Applies operator to operands from stack.
     *
     * @param op
     * @return
     */
    public void apply(Operator op) {

    }

    /**
     * Process input and modify stack accordingly.
     *
     * @param input
     * @return True, unless input that signals the calculator to quit is found, then False
     */
    public boolean processInput(String input) {
        if (isOperator(input)) {
            Operator op = parseOperator(input);
            this.apply(op);
        } else if (isOperand(input)) {
            double operand = parseOperand(input);
            this.push(operand);
        } else if (isQuit(input)) {
            return false;
        } else {
            throw new RuntimeException("Invalid input.");
        }

        return true;
    }

    /**
     * Test if given String s is a valid arithmetic operator.
     *
     * @param s
     * @return
     */
    public static boolean isOperator(String s) {

    }

    /**
     * Return the correct Operator for the given String s.
     *
     * @param s
     * @return the corresponding Operator
     */
    public static Operator parseOperator(String s) {

    }

    /**
     * Test that String s is a valid operand.
     *
     * @param s
     * @return
     */
    public static boolean isOperand(String s) {

    }

    /**
     * Return the double value of the given String s.
     *
     * @param s
     * @return double value of parsed s
     */
    public static double parseOperand(String s) {

    }

    /**
     * Test if String s indicates a quit command.
     *
     * @param s
     * @return
     */
    public static boolean isQuit(String s) {

    }

    /**
     * Process a sequence of operands and operators produced by the given
     * BufferedReader r.
     *
     * This function is used for testing but also for supporting
     * embedding and RpnCalculator in another program.
     *
     * @param calc
     * @param r - contains a sequence of operands and operators
     * @throws IOException
     */
    public static void parse(RpnCalculator calc, BufferedReader r) throws IOException {
        String input = null;
        do {
            input = r.readLine();
            if (input == null) {
                break;
            }
        } while (calc.processInput(input));
    }

    public static void main(String[] args) {

    }
}
